diff --git a/src/main/java/net/minecraft/core/block/RedstoneWireBlock.java b/src/main/java/net/minecraft/core/block/RedstoneWireBlock.java
index c127c1d9c..55328cca5 100644
--- a/src/main/java/net/minecraft/core/block/RedstoneWireBlock.java
+++ b/src/main/java/net/minecraft/core/block/RedstoneWireBlock.java
@@ -1,195 +1,162 @@
 package net.minecraft.core.block;
 
+import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.util.helper.Axis;
-import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.world.WorldSource;
-import net.minecraft.core.world.World;
-import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.helper.Color;
-import net.minecraft.client.util.helper.Colors;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.chunk.ChunkPosition;
 
-import java.util.*;
+import java.util.ArrayList;
+import java.util.HashSet;
+import java.util.Random;
+import java.util.Set;
 
-// Referenced classes of package net.minecraft.src:
-//            Block, Material, World, ChunkPosition, 
-//            Item, IBlockAccess, ModelBed, AxisAlignedBB
+public class RedstoneWireBlock extends Block {
+    private boolean shouldSignal = true;
+    private final Set<ChunkPosition> toUpdate = new HashSet<>();
 
-public class RedstoneWireBlock extends Block
-{
-
-    public RedstoneWireBlock(String key, String namespaceId, int id)
-    {
+    public RedstoneWireBlock(String key, String namespaceId, int id) {
         super(key, namespaceId, id, Material.decoration);
-        wiresProvidePower = true;
-        chunkPositionSet = new HashSet<>();
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.0625F, 1.0F);
     }
 
     @Override
-	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
-    {
+    public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z) {
         return null;
     }
 
     @Override
-	public boolean isSolidRender()
-    {
+    public boolean isSolidRender() {
         return false;
     }
 
     @Override
-	public boolean isCubeShaped()
-    {
+    public boolean isCubeShaped() {
         return false;
     }
 
     @Override
-	public boolean canPlaceBlockAt(World world, int x, int y, int z)
-    {
+    public boolean canPlaceBlockAt(World world, int x, int y, int z) {
         return world.canPlaceOnSurfaceOfBlock(x, y - 1, z);
     }
 
-    private void updateAndPropagateCurrentStrength(World world, int x, int y, int z)
-    {
-        func_21030_a(world, x, y, z, x, y, z);
-        ArrayList<ChunkPosition> arraylist = new ArrayList<>(chunkPositionSet);
-        chunkPositionSet.clear();
-        for (ChunkPosition chunkposition : arraylist) {
-            world.notifyBlocksOfNeighborChange(chunkposition.x, chunkposition.y, chunkposition.z, id);
+    private void updatePowerStrength(World world, int x, int y, int z) {
+        updatePowerStrength(world, x, y, z, x, y, z);
+        ArrayList<ChunkPosition> toUpdate = new ArrayList<>(this.toUpdate);
+        this.toUpdate.clear();
+        for (ChunkPosition pos : toUpdate) {
+            world.notifyBlocksOfNeighborChange(pos.x, pos.y, pos.z, id);
         }
-
     }
 
-    private void func_21030_a(World world, int x, int y, int z, int l, int i1, int j1) {
-        int meta = world.getBlockMetadata(x, y, z);
-        int l1 = 0;
-        wiresProvidePower = false;
-        boolean flag = world.isBlockIndirectlyGettingPowered(x, y, z);
-        wiresProvidePower = true;
-        if(flag) {
-            l1 = 15;
+    private void updatePowerStrength(World world, int x0, int y0, int z0, int x1, int y1, int z1) {
+        int strength = world.getBlockMetadata(x0, y0, z0);
+        int newStrength = 0;
+        shouldSignal = false;
+        boolean hasNeighborSignal = world.hasNeighborSignal(x0, y0, z0);
+        shouldSignal = true;
+        if (hasNeighborSignal) {
+            newStrength = 15;
         } else {
-            for(int i2 = 0; i2 < 4; i2++)
-            {
-                int k2 = x;
-                int i3 = z;
-                if(i2 == 0)
-                {
-                    k2--;
+            for (int i = 0; i < 4; i++) {
+                int xi = x0;
+                int zi = z0;
+                if (i == 0) {
+                    xi--;
                 }
-                if(i2 == 1)
-                {
-                    k2++;
+                if (i == 1) {
+                    xi++;
                 }
-                if(i2 == 2)
-                {
-                    i3--;
+                if (i == 2) {
+                    zi--;
                 }
-                if(i2 == 3)
-                {
-                    i3++;
+                if (i == 3) {
+                    zi++;
                 }
-                if(k2 != l || y != i1 || i3 != j1)
-                {
-                    l1 = getMaxCurrentStrength(world, k2, y, i3, l1);
+                if (xi != x1 || y0 != y1 || zi != z1) {
+                    newStrength = checkTarget(world, xi, y0, zi, newStrength);
                 }
-                if(world.isBlockNormalCube(k2, y, i3) && !world.isBlockNormalCube(x, y + 1, z))
-                {
-                    if(k2 != l || y + 1 != i1 || i3 != j1)
-                    {
-                        l1 = getMaxCurrentStrength(world, k2, y + 1, i3, l1);
+                if (world.isBlockNormalCube(xi, y0, zi) && !world.isBlockNormalCube(x0, y0 + 1, z0)) {
+                    if (xi != x1 || y0 + 1 != y1 || zi != z1) {
+                        newStrength = checkTarget(world, xi, y0 + 1, zi, newStrength);
                     }
                     continue;
                 }
-                if(!world.isBlockNormalCube(k2, y, i3) && (k2 != l || y - 1 != i1 || i3 != j1))
-                {
-                    l1 = getMaxCurrentStrength(world, k2, y - 1, i3, l1);
+                if (!world.isBlockNormalCube(xi, y0, zi) && (xi != x1 || y0 - 1 != y1 || zi != z1)) {
+                    newStrength = checkTarget(world, xi, y0 - 1, zi, newStrength);
                 }
             }
 
-            if(l1 > 0)
-            {
-                l1--;
-            } else
-            {
-                l1 = 0;
+            if (newStrength > 0) {
+                newStrength--;
+            } else {
+                newStrength = 0;
             }
         }
-        if(meta != l1)
-        {
-            world.editingBlocks = true;
-            world.setBlockMetadataWithNotify(x, y, z, l1);
-            world.markBlocksDirty(x, y, z, x, y, z);
-            world.editingBlocks = false;
-            for(int j2 = 0; j2 < 4; j2++)
-            {
-                int l2 = x;
-                int j3 = z;
-                int k3 = y - 1;
-                if(j2 == 0)
-                {
-                    l2--;
+        if (strength != newStrength) {
+            world.noNeighborUpdate = true;
+            world.setBlockMetadataWithNotify(x0, y0, z0, newStrength);
+            world.markBlocksDirty(x0, y0, z0, x0, y0, z0);
+            world.noNeighborUpdate = false;
+            for (int i = 0; i < 4; i++) {
+                int xi = x0;
+                int zi = z0;
+                int yi = y0 - 1;
+                if (i == 0) {
+                    xi--;
                 }
-                if(j2 == 1)
-                {
-                    l2++;
+                if (i == 1) {
+                    xi++;
                 }
-                if(j2 == 2)
-                {
-                    j3--;
+                if (i == 2) {
+                    zi--;
                 }
-                if(j2 == 3)
-                {
-                    j3++;
+                if (i == 3) {
+                    zi++;
                 }
-                if(world.isBlockNormalCube(l2, y, j3))
-                {
-                    k3 += 2;
+                if (world.isBlockNormalCube(xi, y0, zi)) {
+                    yi += 2;
                 }
-                int l3 = 0;
-                l3 = getMaxCurrentStrength(world, l2, y, j3, -1);
-                l1 = world.getBlockMetadata(x, y, z);
-                if(l1 > 0)
-                {
-                    l1--;
+                int targetStrength = 0;
+                targetStrength = checkTarget(world, xi, y0, zi, -1);
+                newStrength = world.getBlockMetadata(x0, y0, z0);
+                if (newStrength > 0) {
+                    newStrength--;
                 }
-                if(l3 >= 0 && l3 != l1)
-                {
-                    func_21030_a(world, l2, y, j3, x, y, z);
+                if (targetStrength >= 0 && targetStrength != newStrength) {
+                    updatePowerStrength(world, xi, y0, zi, x0, y0, z0);
                 }
-                l3 = getMaxCurrentStrength(world, l2, k3, j3, -1);
-                l1 = world.getBlockMetadata(x, y, z);
-                if(l1 > 0)
-                {
-                    l1--;
+                targetStrength = checkTarget(world, xi, yi, zi, -1);
+                newStrength = world.getBlockMetadata(x0, y0, z0);
+                if (newStrength > 0) {
+                    newStrength--;
                 }
-                if(l3 >= 0 && l3 != l1)
-                {
-                    func_21030_a(world, l2, k3, j3, x, y, z);
+                if (targetStrength >= 0 && targetStrength != newStrength) {
+                    updatePowerStrength(world, xi, yi, zi, x0, y0, z0);
                 }
             }
 
-            if(meta == 0 || l1 == 0)
-            {
-                chunkPositionSet.add(new ChunkPosition(x, y, z));
-                chunkPositionSet.add(new ChunkPosition(x - 1, y, z));
-                chunkPositionSet.add(new ChunkPosition(x + 1, y, z));
-                chunkPositionSet.add(new ChunkPosition(x, y - 1, z));
-                chunkPositionSet.add(new ChunkPosition(x, y + 1, z));
-                chunkPositionSet.add(new ChunkPosition(x, y, z - 1));
-                chunkPositionSet.add(new ChunkPosition(x, y, z + 1));
+            if (strength == 0 || newStrength == 0) {
+                toUpdate.add(new ChunkPosition(x0, y0, z0));
+                toUpdate.add(new ChunkPosition(x0 - 1, y0, z0));
+                toUpdate.add(new ChunkPosition(x0 + 1, y0, z0));
+                toUpdate.add(new ChunkPosition(x0, y0 - 1, z0));
+                toUpdate.add(new ChunkPosition(x0, y0 + 1, z0));
+                toUpdate.add(new ChunkPosition(x0, y0, z0 - 1));
+                toUpdate.add(new ChunkPosition(x0, y0, z0 + 1));
             }
         }
     }
 
-    private void notifyWireNeighborsOfNeighborChange(World world, int x, int y, int z)
-    {
+    private void checkCornerChangeAt(World world, int x, int y, int z) {
         if (world.getBlockId(x, y, z) == id) {
             world.notifyBlocksOfNeighborChange(x, y, z, id);
             world.notifyBlocksOfNeighborChange(x - 1, y, z, id);
@@ -202,128 +169,109 @@ public class RedstoneWireBlock extends Block
     }
 
     @Override
-	public void onBlockPlacedByWorld(World world, int x, int y, int z)
-    {
+    public void onBlockPlacedByWorld(World world, int x, int y, int z) {
         super.onBlockPlacedByWorld(world, x, y, z);
-        if(world.isClientSide)
-        {
+        if (world.isClientSide) {
             return;
         }
-        updateAndPropagateCurrentStrength(world, x, y, z);
+        updatePowerStrength(world, x, y, z);
         world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
         world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
-        notifyWireNeighborsOfNeighborChange(world, x - 1, y, z);
-        notifyWireNeighborsOfNeighborChange(world, x + 1, y, z);
-        notifyWireNeighborsOfNeighborChange(world, x, y, z - 1);
-        notifyWireNeighborsOfNeighborChange(world, x, y, z + 1);
-        if(world.isBlockNormalCube(x - 1, y, z))
-        {
-            notifyWireNeighborsOfNeighborChange(world, x - 1, y + 1, z);
-        } else
-        {
-            notifyWireNeighborsOfNeighborChange(world, x - 1, y - 1, z);
-        }
-        if(world.isBlockNormalCube(x + 1, y, z))
-        {
-            notifyWireNeighborsOfNeighborChange(world, x + 1, y + 1, z);
-        } else
-        {
-            notifyWireNeighborsOfNeighborChange(world, x + 1, y - 1, z);
-        }
-        if(world.isBlockNormalCube(x, y, z - 1))
-        {
-            notifyWireNeighborsOfNeighborChange(world, x, y + 1, z - 1);
-        } else
-        {
-            notifyWireNeighborsOfNeighborChange(world, x, y - 1, z - 1);
-        }
-        if(world.isBlockNormalCube(x, y, z + 1))
-        {
-            notifyWireNeighborsOfNeighborChange(world, x, y + 1, z + 1);
-        } else
-        {
-            notifyWireNeighborsOfNeighborChange(world, x, y - 1, z + 1);
+        checkCornerChangeAt(world, x - 1, y, z);
+        checkCornerChangeAt(world, x + 1, y, z);
+        checkCornerChangeAt(world, x, y, z - 1);
+        checkCornerChangeAt(world, x, y, z + 1);
+        if (world.isBlockNormalCube(x - 1, y, z)) {
+            checkCornerChangeAt(world, x - 1, y + 1, z);
+        } else {
+            checkCornerChangeAt(world, x - 1, y - 1, z);
+        }
+        if (world.isBlockNormalCube(x + 1, y, z)) {
+            checkCornerChangeAt(world, x + 1, y + 1, z);
+        } else {
+            checkCornerChangeAt(world, x + 1, y - 1, z);
+        }
+        if (world.isBlockNormalCube(x, y, z - 1)) {
+            checkCornerChangeAt(world, x, y + 1, z - 1);
+        } else {
+            checkCornerChangeAt(world, x, y - 1, z - 1);
+        }
+        if (world.isBlockNormalCube(x, y, z + 1)) {
+            checkCornerChangeAt(world, x, y + 1, z + 1);
+        } else {
+            checkCornerChangeAt(world, x, y - 1, z + 1);
         }
     }
 
     @Override
-    public void onBlockRemoved(World world, int x, int y, int z, int data)
-    {
+    public void onBlockRemoved(World world, int x, int y, int z, int data) {
         super.onBlockRemoved(world, x, y, z, data);
-        if(world.isClientSide)
-        {
+        if (world.isClientSide) {
             return;
         }
         world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
         world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
-        updateAndPropagateCurrentStrength(world, x, y, z);
-        notifyWireNeighborsOfNeighborChange(world, x - 1, y, z);
-        notifyWireNeighborsOfNeighborChange(world, x + 1, y, z);
-        notifyWireNeighborsOfNeighborChange(world, x, y, z - 1);
-        notifyWireNeighborsOfNeighborChange(world, x, y, z + 1);
-        if(world.isBlockNormalCube(x - 1, y, z))
-        {
-            notifyWireNeighborsOfNeighborChange(world, x - 1, y + 1, z);
-        } else
-        {
-            notifyWireNeighborsOfNeighborChange(world, x - 1, y - 1, z);
-        }
-        if(world.isBlockNormalCube(x + 1, y, z))
-        {
-            notifyWireNeighborsOfNeighborChange(world, x + 1, y + 1, z);
-        } else
-        {
-            notifyWireNeighborsOfNeighborChange(world, x + 1, y - 1, z);
-        }
-        if(world.isBlockNormalCube(x, y, z - 1))
-        {
-            notifyWireNeighborsOfNeighborChange(world, x, y + 1, z - 1);
-        } else
-        {
-            notifyWireNeighborsOfNeighborChange(world, x, y - 1, z - 1);
-        }
-        if(world.isBlockNormalCube(x, y, z + 1))
-        {
-            notifyWireNeighborsOfNeighborChange(world, x, y + 1, z + 1);
-        } else
-        {
-            notifyWireNeighborsOfNeighborChange(world, x, y - 1, z + 1);
+        updatePowerStrength(world, x, y, z);
+        checkCornerChangeAt(world, x - 1, y, z);
+        checkCornerChangeAt(world, x + 1, y, z);
+        checkCornerChangeAt(world, x, y, z - 1);
+        checkCornerChangeAt(world, x, y, z + 1);
+        if (world.isBlockNormalCube(x - 1, y, z)) {
+            checkCornerChangeAt(world, x - 1, y + 1, z);
+        } else {
+            checkCornerChangeAt(world, x - 1, y - 1, z);
+        }
+        if (world.isBlockNormalCube(x + 1, y, z)) {
+            checkCornerChangeAt(world, x + 1, y + 1, z);
+        } else {
+            checkCornerChangeAt(world, x + 1, y - 1, z);
+        }
+        if (world.isBlockNormalCube(x, y, z - 1)) {
+            checkCornerChangeAt(world, x, y + 1, z - 1);
+        } else {
+            checkCornerChangeAt(world, x, y - 1, z - 1);
+        }
+        if (world.isBlockNormalCube(x, y, z + 1)) {
+            checkCornerChangeAt(world, x, y + 1, z + 1);
+        } else {
+            checkCornerChangeAt(world, x, y - 1, z + 1);
         }
     }
 
-    private int getMaxCurrentStrength(World world, int x, int y, int z, int inputMeta) {
-        if(world.getBlockId(x, y, z) != id) {
-            return inputMeta;
+    private int checkTarget(World world, int x, int y, int z, int sourceStrength) {
+        if (world.getBlockId(x, y, z) != id) {
+            return sourceStrength;
         }
 
-        int meta = world.getBlockMetadata(x, y, z);
-        return Math.max(meta, inputMeta);
+        int targetStrength = world.getBlockMetadata(x, y, z);
+        return Math.max(targetStrength, sourceStrength);
     }
 
     @Override
-	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
-        if(world.isClientSide) {return;}
+    public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
+        if (world.isClientSide) {
+            return;
+        }
 
-        int meta = world.getBlockMetadata(x, y, z);
-        boolean flag = canPlaceBlockAt(world, x, y, z);
-        if(!flag) {
-            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, meta, null, null);
+        int strength = world.getBlockMetadata(x, y, z);
+        boolean canPlaceBlockAt = canPlaceBlockAt(world, x, y, z);
+        if (!canPlaceBlockAt) {
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, strength, null, null);
             world.setBlockWithNotify(x, y, z, 0);
         } else {
-            updateAndPropagateCurrentStrength(world, x, y, z);
+            updatePowerStrength(world, x, y, z);
         }
         super.onNeighborBlockChange(world, x, y, z, blockId);
     }
 
     @Override
     public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity) {
-        return new ItemStack[] { new ItemStack(Items.DUST_REDSTONE ) };
+        return new ItemStack[]{new ItemStack(Items.DUST_REDSTONE)};
     }
 
     @Override
-    public boolean getDirectSignal(World world, int x, int y, int z, Side side)
-    {
-        if(!wiresProvidePower) {
+    public boolean getDirectSignal(World world, int x, int y, int z, Side side) {
+        if (!shouldSignal) {
             return false;
         } else {
             return getSignal(world, x, y, z, side);
@@ -331,115 +279,100 @@ public class RedstoneWireBlock extends Block
     }
 
     @Override
-    public boolean getSignal(WorldSource blockAccess, int x, int y, int z, Side side)
-    {
-        if(!wiresProvidePower) {
+    public boolean getSignal(WorldSource worldSource, int x, int y, int z, Side side) {
+        if (!shouldSignal) {
             return false;
         }
-        if(blockAccess.getBlockMetadata(x, y, z) == 0) {
+        if (worldSource.getBlockMetadata(x, y, z) == 0) {
             return false;
         }
-        if(side == Side.TOP) {
+        if (side == Side.TOP) {
             return true;
         }
-        boolean flag = isPowerProviderOrWire(blockAccess, x - 1, y, z, 1) || !blockAccess.isBlockNormalCube(x - 1, y, z) && isPowerProviderOrWire(blockAccess, x - 1, y - 1, z, -1);
-        boolean flag1 = isPowerProviderOrWire(blockAccess, x + 1, y, z, 3) || !blockAccess.isBlockNormalCube(x + 1, y, z) && isPowerProviderOrWire(blockAccess, x + 1, y - 1, z, -1);
-        boolean flag2 = isPowerProviderOrWire(blockAccess, x, y, z - 1, 2) || !blockAccess.isBlockNormalCube(x, y, z - 1) && isPowerProviderOrWire(blockAccess, x, y - 1, z - 1, -1);
-        boolean flag3 = isPowerProviderOrWire(blockAccess, x, y, z + 1, 0) || !blockAccess.isBlockNormalCube(x, y, z + 1) && isPowerProviderOrWire(blockAccess, x, y - 1, z + 1, -1);
-        if(!blockAccess.isBlockNormalCube(x, y + 1, z))
-        {
-            if(blockAccess.isBlockNormalCube(x - 1, y, z) && isPowerProviderOrWire(blockAccess, x - 1, y + 1, z, -1))
-            {
-                flag = true;
+        boolean negXShouldConnectTo = shouldConnectTo(worldSource, x - 1, y, z, 1) || !worldSource.isBlockNormalCube(x - 1, y, z) && shouldConnectTo(worldSource, x - 1, y - 1, z, -1);
+        boolean posXShouldConnectTo = shouldConnectTo(worldSource, x + 1, y, z, 3) || !worldSource.isBlockNormalCube(x + 1, y, z) && shouldConnectTo(worldSource, x + 1, y - 1, z, -1);
+        boolean negZShouldConnectTo = shouldConnectTo(worldSource, x, y, z - 1, 2) || !worldSource.isBlockNormalCube(x, y, z - 1) && shouldConnectTo(worldSource, x, y - 1, z - 1, -1);
+        boolean posZShouldConnectTo = shouldConnectTo(worldSource, x, y, z + 1, 0) || !worldSource.isBlockNormalCube(x, y, z + 1) && shouldConnectTo(worldSource, x, y - 1, z + 1, -1);
+        if (!worldSource.isBlockNormalCube(x, y + 1, z)) {
+            if (worldSource.isBlockNormalCube(x - 1, y, z) && shouldConnectTo(worldSource, x - 1, y + 1, z, -1)) {
+                negXShouldConnectTo = true;
             }
-            if(blockAccess.isBlockNormalCube(x + 1, y, z) && isPowerProviderOrWire(blockAccess, x + 1, y + 1, z, -1))
-            {
-                flag1 = true;
+            if (worldSource.isBlockNormalCube(x + 1, y, z) && shouldConnectTo(worldSource, x + 1, y + 1, z, -1)) {
+                posXShouldConnectTo = true;
             }
-            if(blockAccess.isBlockNormalCube(x, y, z - 1) && isPowerProviderOrWire(blockAccess, x, y + 1, z - 1, -1))
-            {
-                flag2 = true;
+            if (worldSource.isBlockNormalCube(x, y, z - 1) && shouldConnectTo(worldSource, x, y + 1, z - 1, -1)) {
+                negZShouldConnectTo = true;
             }
-            if(blockAccess.isBlockNormalCube(x, y, z + 1) && isPowerProviderOrWire(blockAccess, x, y + 1, z + 1, -1))
-            {
-                flag3 = true;
+            if (worldSource.isBlockNormalCube(x, y, z + 1) && shouldConnectTo(worldSource, x, y + 1, z + 1, -1)) {
+                posZShouldConnectTo = true;
             }
         }
-        if(!flag2 && !flag1 && !flag && !flag3 && side.getAxis() != Axis.Y)
-        {
+        if (!negZShouldConnectTo && !posXShouldConnectTo && !negXShouldConnectTo && !posZShouldConnectTo && side.getAxis() != Axis.Y) {
             return true;
         }
-        if(side == Side.NORTH && flag2 && !flag && !flag1)
-        {
+        if (side == Side.NORTH && negZShouldConnectTo && !negXShouldConnectTo && !posXShouldConnectTo) {
             return true;
         }
-        if(side == Side.SOUTH && flag3 && !flag && !flag1)
-        {
+        if (side == Side.SOUTH && posZShouldConnectTo && !negXShouldConnectTo && !posXShouldConnectTo) {
             return true;
         }
-        if(side == Side.WEST && flag && !flag2 && !flag3)
-        {
+        if (side == Side.WEST && negXShouldConnectTo && !negZShouldConnectTo && !posZShouldConnectTo) {
             return true;
         }
-        return side == Side.EAST && flag1 && !flag2 && !flag3;
+        return side == Side.EAST && posXShouldConnectTo && !negZShouldConnectTo && !posZShouldConnectTo;
     }
 
     @Override
-    public boolean isSignalSource()
-    {
-        return wiresProvidePower;
+    public boolean isSignalSource() {
+        return shouldSignal;
     }
 
-	@Override
-	public void animationTick(World world, int x, int y, int z, Random rand) {
-		int meta = world.getBlockMetadata(x, y, z);
-		if(meta == 0) {
-			return;
-		}
-		double px = (double) x + 0.5D + (rand.nextFloat() - 0.5D) * 0.2D;
-		double py = (double) y + 0.0625D;
-		double pz = (double) z + 0.5D + (rand.nextFloat() - 0.5D) * 0.2D;
+    @Override
+    public void animationTick(World world, int x, int y, int z, Random rand) {
+        int meta = world.getBlockMetadata(x, y, z);
+        if (meta == 0) {
+            return;
+        }
+        double px = (double) x + 0.5D + (rand.nextFloat() - 0.5D) * 0.2D;
+        double py = (double) y + 0.0625D;
+        double pz = (double) z + 0.5D + (rand.nextFloat() - 0.5D) * 0.2D;
 
         final int redstoneBrightness = meta & 0xF;
-		Color color = Colors.allRedstoneColors[redstoneBrightness];
-		if(color == null) {
-			return;
-		}
-		float red = color.getRed() / 255.0f;
-		float green = color.getGreen() / 255.0f;
-		float blue = color.getBlue() / 255.0f;
+        Color color = Colors.allRedstoneColors[redstoneBrightness];
+        if (color == null) {
+            return;
+        }
+        float red = color.getRed() / 255.0f;
+        float green = color.getGreen() / 255.0f;
+        float blue = color.getBlue() / 255.0f;
 
-		world.spawnParticle("reddust", px, py, pz, red, green, blue, redstoneBrightness);
-	}
+        world.spawnParticle("reddust", px, py, pz, red, green, blue, redstoneBrightness);
+    }
 
-    public static boolean isPowerProviderOrWire(WorldSource worldSource, int x, int y, int z, int l)
-    {
+    public static boolean shouldConnectTo(WorldSource worldSource, int x, int y, int z, int data) {
         int blockId = worldSource.getBlockId(x, y, z);
-        if(blockId == Blocks.WIRE_REDSTONE.id) {
+        if (blockId == Blocks.WIRE_REDSTONE.id) {
             return true;
         }
-        if(blockId <= 0) {
+        if (blockId <= 0) {
             return false;
         }
-        if(Block.blocksList[blockId].isSignalSource()) {
+        if (Block.blocksList[blockId].isSignalSource()) {
             return true;
         }
         if (blockId == Blocks.PUMPKIN_REDSTONE.id) {
-            if (l < 0 || l > 3) {
+            if (data < 0 || data > 3) {
                 return false;
             }
-            Side[] lookup = { Side.NORTH, Side.EAST, Side.SOUTH, Side.WEST };
+            Side[] lookup = {Side.NORTH, Side.EAST, Side.SOUTH, Side.WEST};
             Side side = Side.getSideById(worldSource.getBlockMetadata(x, y, z));
-            return side == lookup[l];
+            return side == lookup[data];
         }
-        if(blockId == Blocks.REPEATER_IDLE.id || blockId == Blocks.REPEATER_ACTIVE.id) {
+        if (blockId == Blocks.REPEATER_IDLE.id || blockId == Blocks.REPEATER_ACTIVE.id) {
             int meta = worldSource.getBlockMetadata(x, y, z);
-            return l == BedBlock.footToHeadMap[meta & 0b11];
+            return data == BedBlock.footToHeadMap[meta & 0b11];
         } else {
             return false;
         }
     }
-
-    private boolean wiresProvidePower;
-    private final Set<ChunkPosition> chunkPositionSet;
 }
diff --git a/src/main/java/net/minecraft/core/block/RepeaterBlock.java b/src/main/java/net/minecraft/core/block/RepeaterBlock.java
index 680360b39..d0bef696c 100644
--- a/src/main/java/net/minecraft/core/block/RepeaterBlock.java
+++ b/src/main/java/net/minecraft/core/block/RepeaterBlock.java
@@ -81,11 +81,11 @@ public class RepeaterBlock extends Block
     }
 
     @Override
-    public boolean getSignal(WorldSource blockAccess, int x, int y, int z, Side side) {
+    public boolean getSignal(WorldSource worldSource, int x, int y, int z, Side side) {
         if(!isRepeaterPowered) {
             return false;
         }
-        int meta = blockAccess.getBlockMetadata(x, y, z) & 3;
+        int meta = worldSource.getBlockMetadata(x, y, z) & 3;
         if(meta == 0 && side == Side.SOUTH) {
             return true;
         }
@@ -121,16 +121,16 @@ public class RepeaterBlock extends Block
         switch(direction)
         {
         case 0: // '\0'
-            return world.isBlockIndirectlyProvidingPowerTo(x, y, z + 1, Side.SOUTH) || world.getBlockId(x, y, z + 1) == Blocks.WIRE_REDSTONE.id && world.getBlockMetadata(x, y, z + 1) > 0;
+            return world.getSignal(x, y, z + 1, Side.SOUTH) || world.getBlockId(x, y, z + 1) == Blocks.WIRE_REDSTONE.id && world.getBlockMetadata(x, y, z + 1) > 0;
 
         case 2: // '\002'
-            return world.isBlockIndirectlyProvidingPowerTo(x, y, z - 1, Side.NORTH) || world.getBlockId(x, y, z - 1) == Blocks.WIRE_REDSTONE.id && world.getBlockMetadata(x, y, z - 1) > 0;
+            return world.getSignal(x, y, z - 1, Side.NORTH) || world.getBlockId(x, y, z - 1) == Blocks.WIRE_REDSTONE.id && world.getBlockMetadata(x, y, z - 1) > 0;
 
         case 3: // '\003'
-            return world.isBlockIndirectlyProvidingPowerTo(x + 1, y, z, Side.EAST) || world.getBlockId(x + 1, y, z) == Blocks.WIRE_REDSTONE.id && world.getBlockMetadata(x + 1, y, z) > 0;
+            return world.getSignal(x + 1, y, z, Side.EAST) || world.getBlockId(x + 1, y, z) == Blocks.WIRE_REDSTONE.id && world.getBlockMetadata(x + 1, y, z) > 0;
 
         case 1: // '\001'
-            return world.isBlockIndirectlyProvidingPowerTo(x - 1, y, z, Side.WEST) || world.getBlockId(x - 1, y, z) == Blocks.WIRE_REDSTONE.id && world.getBlockMetadata(x - 1, y, z) > 0;
+            return world.getSignal(x - 1, y, z, Side.WEST) || world.getBlockId(x - 1, y, z) == Blocks.WIRE_REDSTONE.id && world.getBlockMetadata(x - 1, y, z) > 0;
         }
         return false;
     }
diff --git a/src/main/java/net/minecraft/core/block/SlabBlock.java b/src/main/java/net/minecraft/core/block/SlabBlock.java
index 50fb2099f..dbc0925fe 100644
--- a/src/main/java/net/minecraft/core/block/SlabBlock.java
+++ b/src/main/java/net/minecraft/core/block/SlabBlock.java
@@ -70,7 +70,7 @@ public class SlabBlock extends Block
     }
 
     @Override
-    public boolean renderAsNormalBlockOnCondition(World world, int x, int y, int z)
+    public boolean renderAsNormalBlockOnCondition(WorldSource world, int x, int y, int z)
     {
         int meta = world.getBlockMetadata(x, y, z);
         return (meta & 0x3) == 1;
